﻿using UnityEngine;
public class NailProjectileBehaviour : MonoBehaviour
{

    Transform speener;

    void Awake()
    {
        speener = new GameObject().transform;
        speener.parent = transform;
        speener.localPosition = Vector3.zero;
        speener.localScale = Vector3.one;
        speener.localRotation = Quaternion.Euler(0f, 0f, 0f);

        var spin1 = new GameObject().transform;
        spin1.parent = speener;
        spin1.localPosition = Vector3.zero;
        spin1.localScale = Vector3.one;
        spin1.localRotation = Quaternion.Euler(0f, 0f, 0f);
        spin1.gameObject.AddComponent<SpriteRenderer>().sprite = ModResources.nailspinSprite;

        var spin2 = new GameObject().transform;
        spin2.parent = speener;
        spin2.localPosition = Vector3.zero;
        spin2.localScale = Vector3.one;
        spin2.localRotation = Quaternion.Euler(90f, 0f, 0f);
        spin2.gameObject.AddComponent<SpriteRenderer>().sprite = ModResources.nailspinSprite;
    }

    void Update()
    {
        speener.Rotate(550f * Time.deltaTime, 0f, 0f);
    }

    void Lodged(Stabbing stabbing)
    {
        if (stabbing.victim.gameObject.layer != 11)
        {
            if (stabbing.victim.TryGetComponent<LimbBehaviour>(out var limb))
            {
                foreach(var limbs in limb.Person.Limbs)
                    limbs.Wince(Random.Range(5, 10f));

                limb.CirculationBehaviour.BleedingRate += 5f;
                limb.CirculationBehaviour.BloodLossRateMultiplier += 5f;

                foreach (var bloodPart in limb.CirculationBehaviour.BleedingParticles)
                {
                    var bpb = bloodPart.GetComponent<BleedingParticleBehaviour>();
                    bpb.SpeedMultiplier += 8f;
                    bpb.RateMultiplier += 5f;

                    var col = bpb.BloodParticleSystem.collision;
                    col.enabled = true;
                    col.colliderForce = bpb.SpeedMultiplier;
                }
            }
        }
    }
}
